<?php
class plgHikashoppaymentPaypalrecurring extends JPlugin
{

	var $accepted_currencies = array(
		'CAD','EUR','GBP','JPY','USD','AUD','ILS'
	);
	var $debugData = array();
	function onPaymentDisplay(&$order,&$methods,&$usable_methods){
		 if(!empty($methods)){
			foreach($methods as $method){
				if($method->payment_type!='paypalrecurring' || !$method->enabled){
					continue;
				}
				//remove the paypal method if a zone is set for it and that the address of the user is not in that zone
				if(!empty($method->payment_zone_namekey)){
					$zoneClass=hikashop_get('class.zone');
						$zones = $zoneClass->getOrderZones($order);
					if(!in_array($method->payment_zone_namekey,$zones)){
						return true;
					}
				}

				//check that the currency of the cart can be used with this payment method
				$currencyClass = hikashop_get('class.currency');
				$null=null;
				if(!empty($order->total)){
					$currency_id = intval(@$order->total->prices[0]->price_currency_id);
					$currency = $currencyClass->getCurrencies($currency_id,$null);
					if(!empty($currency) && !in_array(@$currency[$currency_id]->currency_code,$this->accepted_currencies)){
						return true;
					}
				}

				//if we don't want to use the built-in payment method description view, we can generate our own

				// If order recurring option enabled, display paypal recurring


				if($method->payment_params->recurring_type == 'global'){
					$method->custom_html='<tr><td></td><td></td><td><select id="hikashop_payment_paypal_recurring_period_'.$method->payment_id.'" name="hikashop_payment_paypal_recurring_period_'.$method->payment_id.'">';
					$values = explode(',',$method->payment_params->recurring_period);
					foreach($values as $value){
						$method->custom_html.='<option value="'.$value.'">'.$value.'</option>';
					}
					$method->custom_html.='</select> '.JText::_('SELECT_RECURRING_PERIOD').'</td></tr>';
				}elseif($method->payment_params->recurring_type == 'instalments'){
					$values = explode(',',$method->payment_params->recurring_times);
					if(count($values) > 1){
						$method->custom_html='<tr><td></td><td></td><td><select id="hikashop_payment_paypal_recurring_times_'.$method->payment_id.'" name="hikashop_payment_paypal_recurring_times_'.$method->payment_id.'">';
						foreach($values as $value){
							$method->custom_html.='<option value="'.$value.'">'.$value.'</option>';
						}
						$method->custom_html.='</select> '.JText::_('SELECT_RECURRING_TIMES').'</td></tr>';
					}else{
						$method->custom_html='<tr><td></td><td></td><td>'.JText::sprintf('RECURRING_TIMES_VALUE',$values[0]).'</td></tr>';
					}

				}else{
					$method->recurring = 1;
				}
				$usable_methods[$method->ordering]=$method;
			}
		}
		return true;
	}

	function onPaymentSave(&$cart,&$rates,&$payment_id){
		$usable = array();
		$this->onPaymentDisplay($cart,$rates,$usable);
		$payment_id = (int) $payment_id;

		$app = JFactory::getApplication();
		$app->setUserState('recurring_period',JRequest::getVar('hikashop_payment_paypal_recurring_period_'.$payment_id,'30'));
		$app->setUserState('recurring_times',JRequest::getVar('hikashop_payment_paypal_recurring_times_'.$payment_id,'0'));
		// check that the shipping selected can be used
		foreach($usable as $usable_method){
			if($usable_method->payment_id==$payment_id){
				return $usable_method;
			}
		}

		return false;
	}

	function onAfterOrderConfirm(&$order,&$methods,$method_id){
		$app = JFactory::getApplication();
		$method =& $methods[$method_id];
		//direct to paypal
		$tax_total = '';
		$discount_total = '';
		$currencyClass = hikashop_get('class.currency');
		$currencies=null;
		$currencies = $currencyClass->getCurrencies($order->order_currency_id,$currencies);
		$currency=$currencies[$order->order_currency_id];
		if($currency->currency_locale['int_frac_digits']>2)$currency->currency_locale['int_frac_digits']=2;
		hikashop_loadUser(true,true); //reset user data in case the emails were changed in the email code
		$user = hikashop_loadUser(true);
		$lang = JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));
		global $Itemid;
		$url_itemid='';
		if(!empty($Itemid)){
			$url_itemid='&Itemid='.$Itemid;
		}

/* TEMP - Clone the order, edit it as under order, save it, change the main order status to completed */
		if($method->payment_params->recurring_type == 'instalments'/* && (!isset($order->old->order_full_price) || (isset($order->old->order_full_price) && $order->old->order_full_price != ($order->order_full_price * $method->payment_params->recurring_times)))*/){
			$orderClass = hikashop_get('class.order');
			$subOrder = clone $order;
			unset($order->order_url);
			//$orderClass->save($order);
			$subOrder->old = $order;
			unset($subOrder->order_url);
			$subOrder->order_id = '';
			$subOrder->cart->order_id = '';
			$subOrder->order_number = '';
			$subOrder->cart->order_number = '';
			if(!isset($subOrder->order_full_price) || !isset($subOrder->old->order_full_price) || $subOrder->order_full_price == $subOrder->old->order_full_price){
				$subOrder->order_full_price = (float)$order->order_full_price / (int)$method->payment_params->recurring_times;
				$subOrder->order->order_full_price = $subOrder->order_full_price;
				$subOrder->cart->order_full_price = $subOrder->order_full_price;
				$subOrder->cart->full_total->prices[0]->price_value_with_tax = $subOrder->order_full_price;
			}
			// Add payment params to specify the parent order id, number of recurring, the current instalment.
			$payment_params = array();

			if(isset($order->cart->products[0]->order_id))
				$payment_params['parent_order_id'] = $order->cart->products[0]->order_id;
			else
				$payment_params['parent_order_id'] = $order->cart->order_id;
			$payment_params['total_instalment'] = $method->payment_params->recurring_times;
			$payment_params['current_instalment'] = 1;
			$subOrder->order_payment_params = serialize($payment_params);

			// Remove some prices for the installment order
			$subOrder->order_tax_info = array();
			$subOrder->order_payment_price = 0;
			$subOrder->order_shipping_price = 0;
			$subOrder->order_shipping_tax = 0;
			$subOrder->order_shipping_params->prices = array();
			$subOrder->cart->order_tax_info = array();
			$subOrder->cart->order_shipping_price = 0;
			$subOrder->cart->shippings = array();
			$subOrder->cart->payments = array();
			$subOrder->cart->order_payment_price = 0;
			$subOrder->cart->coupon->discount_value = 0;

			$order->cart->products = array();
			$order->cart->products[0]->product_id = 0;
			$order->cart->products[0]->order_product_id = 0;
			$order->cart->products[0]->order_id = $payment_params['parent_order_id'];
			$order->cart->products[0]->order_product_quantity = 1;
			$order->cart->products[0]->order_product_name = JText::sprintf('INSTALLMENT_FOR_ORDER',$payment_params['parent_order_id']);
			$order->cart->products[0]->order_product_code = str_replace(' ','_',strtolower(JText::sprintf('INSTALLMENT_FOR_ORDER',$payment_params['parent_order_id'])));
			$order->cart->products[0]->order_product_price = $subOrder->order_full_price;
			$order->cart->products[0]->order_product_tax = 0;
			$order->cart->products[0]->order_product_options = '';
			$order->cart->products[0]->order_product_option_parent_id = 0;
			$order->cart->products[0]->order_product_total_price_no_vat = $subOrder->order_full_price;
			$order->cart->products[0]->order_product_total_price = $subOrder->order_full_price;
			$order->cart->products[0]->images = array();

			$orderClass->save($subOrder);
			$order = $subOrder;
		}

		$params = null;
		$notify_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=paypalrecurring&tmpl=component&lang='.$locale.$url_itemid;
		$return_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id='.$order->order_id.$url_itemid;
		$cancel_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order&task=cancel_order&order_id='.$order->order_id.$url_itemid;

		$debug = $method->payment_params->debug;
		if(!isset($method->payment_params->no_shipping)) $method->payment_params->no_shipping = 1;
		if(!empty($method->payment_params->rm)) $method->payment_params->rm = 2;

		$productIds = array();
		$order->cart->order_full_quantity = 0;
		foreach($order->cart->products as $k => $product){
			$productIds[$k] = (int)$product->product_id;
			$order->cart->order_full_quantity += $product->order_product_quantity;
		}

		if($method->payment_params->recurring_type == 'subscription'){
			//Select all the subscription_level_id for all the products in HikaShop
			$subLevel = 0;
			$db	=& JFactory::getDBO();
			$query = 'SELECT product_id, product_subscription_id FROM '.hikashop_table('product',true).' WHERE product_id IN ('.implode(',',$productIds).')';
			$db->setQuery($query);
			$results = $db->loadObjectList();
			foreach($order->cart->products as $k => $product){
				foreach($results as $result){
					if($order->cart->products[$k]->product_id == $result->product_id)
						$order->cart->products[$k]->product_subscription_id = $result->product_subscription_id;
				}
			}
		}

		//Variable for signup && payment
		$vars = array(
			"cmd" => '_xclick-subscriptions',
			"business" => $method->payment_params->email,
			"receiver_email" => $method->payment_params->email,
			"invoice" => $order->order_id,
			"currency_code" => $currency->currency_code,
			"mc_currency" => $currency->currency_code,
			"return" => $return_url,
			"notify_url" => $notify_url,
			"cancel_return" => $cancel_url,
			"no_shipping" => $method->payment_params->no_shipping,
			"no_note" => "1",
			"test_ipn" => $debug,
			"txn_type" => "subscr_payment",
			"rm"=>(int)@$method->payment_params->rm
		);
		// Set the environement
		if($method->payment_params->environnement == 'sandbox'){
			 $vars["url"] = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
		} else {
			 $vars["url"] = 'https://www.paypal.com/cgi-bin/webscr';
		}
		// User informations
		if(!empty($method->payment_params->address_type)){
			$address_type = $method->payment_params->address_type.'_address';
			$address=$app->getUserState( HIKASHOP_COMPONENT.'.'.$address_type);
			if(!empty($address)){
				if(!isset($method->payment_params->address_override)){
					$method->payment_params->address_override = '1';
				}
				$vars["address_override"]=$method->payment_params->address_override;
				$cart = hikashop_get('class.cart');
				$cart->loadAddress($order->cart,$address,'object',$method->payment_params->address_type);

				$vars["first_name"]=@$order->cart->$address_type->address_firstname;
				$vars["last_name"]=@$order->cart->$address_type->address_lastname;
				$address1 = '';
				$address2 = '';
				if(!empty($order->cart->$address_type->address_street2)){
					$address2 = substr($order->cart->$address_type->address_street2,0,99);
				}
				if(!empty($order->cart->$address_type->address_street)){
					if(strlen($order->cart->$address_type->address_street)>100){
						$address1 = substr($order->cart->$address_type->address_street,0,99);
						if(empty($address2)) $address2 = substr($order->cart->$address_type->address_street,99,199);
					}else{
						$address1 = $order->cart->$address_type->address_street;
					}
				}

				$vars["address1"]=$address1;
				$vars["address2"]=$address2;
				$vars["city"]=@$order->cart->$address_type->address_city;
				$vars["state"]=@$order->cart->$address_type->address_state->zone_code_2;
				$vars["zip"]=@$order->cart->$address_type->address_post_code;
				$vars["country"]=@$order->cart->$address_type->address_country->zone_code_2;
				$vars["payer_email"]=$user->user_email;
				$vars["payer_id"]=$user->user_id;
			}elseif(!empty($order->cart->billing_address->address_country->zone_code_2)){
				$vars["lc"]=$order->cart->billing_address->address_country->zone_code_2;
			}
		}elseif(!empty($order->cart->billing_address->address_country->zone_code_2)){
			$vars["lc"]=$order->cart->billing_address->address_country->zone_code_2;
		}
		if(!empty($method->payment_params->cpp_header_image)){
			$vars['cpp_header_image']=$method->payment_params->cpp_header_image;
		}
		// Product information (if 1 product > name of the product // else echo "total price")
		if($order->cart->order_full_quantity == 1){
			$vars["item_name"]=strip_tags($order->cart->products[0]->order_product_name);
		}else{
			$vars["item_name"]=JText::_('CART_PRODUCT_TOTAL_PRICE');
		}
		$vars["item_number"]=$order->cart->order_full_quantity;
		$subLevel = array();
		$app = JFactory::getApplication();
		if($method->payment_params->recurring_type == 'subscription'){
			foreach($order->cart->products as $k => $product){
				$subLevel[$k] = $product->product_subscription_id;
			}
			$subs = array();
			$dispatcher = JDispatcher::getInstance();
			$dispatcher->trigger('onCheckSubscription', array( &$subLevel,&$subs ) );
			$duration = 0;
			$subPrice = 0;

			if(isset($subs) && !empty($subs)){
				foreach($subs as $k => $sub){
					foreach($order->cart->products as $k => $product){
						if($product->product_subscription_id == $sub->akeebasubs_level_id){
							$duration = $sub->duration;
							$subPrice += $sub->price * $product->order_product_quantity;
						}
					}
				}
			}
		}else{
			// Get the chosen value of the user
			if($method->payment_params->recurring_type == 'global'){
				$duration = $app->getUserState('recurring_period','30');
			}else{
				$duration = '31';
			}
		}
		$ppDuration = $this->_toPPDuration($duration);
		// Force the price of HikaShop if not default recurring type
		if($method->payment_params->recurring_type != 'subscription'){
			$priceFrom = 'hikashop';
		}else{
			$priceFrom = $method->payment_params->price_from;
		}
		// Select the price from hikashop / subscription component (depending on the option)
		if($priceFrom == 'hikashop'){
			//$vars["a3"] = round($order->cart->full_total->prices[0]->price_value_with_tax,(int)$currency->currency_locale['int_frac_digits']);
			$vars["a3"] = round($order->order_full_price,(int)$currency->currency_locale['int_frac_digits']);
		}else{
			$vars["a3"] = round($subPrice + $order->cart->order_shipping_price + $order->cart->order_payment_price,(int)$currency->currency_locale['int_frac_digits']);
		}
		$vars["p3"]=$ppDuration->value; // Recurring time
		$vars["t3"]=$ppDuration->unit; // Recurring time unit
		$vars["src"]=1; // Recurring payments
		$vars["sra"]=isset($method->payment_params->reattempt)?$method->payment_params->reattempt:1; // Reattempt on failure, default = 1
		// Number of recurring times, if period = 1 month and srt = 4, so there will be 4 payments
		if($method->payment_params->recurring_times != '0'){
			$vars["srt"]= (int)$method->payment_params->recurring_times;
		}

		if(!HIKASHOP_J30)
			JHTML::_('behavior.mootools');
		else
			JHTML::_('behavior.framework');

		$name = $method->payment_type.'_end.php';
		$path = JPATH_THEMES.DS.$app->getTemplate().DS.'hikashoppayment'.DS.$name;
		if(!file_exists($path)){
			if(version_compare(JVERSION,'1.6','<')){
				$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$name;
			}else{
				$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$method->payment_type.DS.$name;
			}
			if(!file_exists($path)){
				//that should not happen !
				return true;
			}
		}
		require($path);

		return true;
	}

	function onPaymentNotification(&$statuses){

		echo str_repeat('-', 80)."\nLog PayPal recurring :".date("d-m-Y")." -- ".date("H:i")."\n".str_repeat('-', 80)."\n";

		$pluginsClass = hikashop_get('class.plugins');
		$elements = $pluginsClass->getMethods('payment','paypalrecurring');
		if(empty($elements)) return false;

		$element = reset($elements);

		if(!$element->payment_params->notification){
			return false;
		}
		//ipn handling
		$vars = array();
		$data = array();
		$filter = JFilterInput::getInstance();
		foreach($_REQUEST as $key => $value){
			$key = $filter->clean($key);
			if(preg_match("#^[0-9a-z_-]{1,30}$#i",$key)&&!preg_match("#^cmd$#i",$key)){
				$value = JRequest::getString($key);
				$vars[$key]=$value;
				$data[]=$key.'='.urlencode($value);
			}
		}

		$data = implode('&',$data).'&cmd=_notify-validate';
		if($element->payment_params->debug){
			echo print_r($vars,true)."\n\n\n";
		}
			//load order
		$orderClass = hikashop_get('class.order');

		$dbOrder = $orderClass->get((int)@$vars['invoice']);
		$fullOrder = $orderClass->loadFullOrder((int)@$vars['invoice'],true,false);

		if(empty($dbOrder)){
			//no email is sent and the page processing is stopped to avoid flood
			echo "Could not load any order for your notification ".@$vars['invoice'];
			return false;
		}

		$order = new stdClass();
		$order->order_id = $dbOrder->order_id;
		$order->order_number = $dbOrder->order_number;
		$order->order_full_price = $dbOrder->order_full_price;
		$order->order_currency_id = $dbOrder->order_currency_id;
		$order->order_tax_info = $dbOrder->order_tax_info;
		$order->old_status->order_status=$dbOrder->order_status;
		$url = HIKASHOP_LIVE.'administrator/index.php?option=com_hikashop&ctrl=order&task=edit&order_id='.$order->order_id;
		$order_text = "\r\n".JText::sprintf('NOTIFICATION_OF_ORDER_ON_WEBSITE',$dbOrder->order_number,HIKASHOP_LIVE);
		$order_text .= "\r\n".str_replace('<br/>',"\r\n",JText::sprintf('ACCESS_ORDER_WITH_LINK',$url));

	//If recurring > new order must have the same informations than the previous one.
		if($order->old_status->order_status == 'confirmed'){
			$order = $dbOrder;
			$order->old_status->order_status = $order->order_status;
			$order->cart->billing_address = $fullOrder->billing_address;
			$order->cart->shipping_address = $fullOrder->shipping_address;
		}

		if($element->payment_params->debug){
			echo str_repeat('-', 80)."\n";
			echo print_r($dbOrder,true)."\n\n\n";
			echo str_repeat('-', 80)."\n";
		}
		$mailer = JFactory::getMailer();
		$config =& hikashop_config();
		$sender = array(
				$config->get('from_email'),
				$config->get('from_name') );
		$mailer->setSender($sender);
		$mailer->addRecipient(explode(',',$config->get('payment_notification_email')));
			//check IP if the user wants
			if(!empty($element->payment_params->ips)){
				$ip = hikashop_getIP();
				$ips = str_replace(array('.','*',','),array('\.','[0-9]+','|'),$element->payment_params->ips);
				if(!preg_match('#('.implode('|',$ips).')#',$ip)){
					//send an email
				$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','Paypal').' '.JText::sprintf('IP_NOT_VALID',$dbOrder->order_number));
				$body = str_replace('<br/>',"\r\n",JText::sprintf('NOTIFICATION_REFUSED_FROM_IP','Paypal',$ip,implode("\r\n",$element->payment_params->ips)))."\r\n\r\n".JText::sprintf('CHECK_DOCUMENTATION',HIKASHOP_HELPURL.'payment-paypal-error#ip').$order_text;
				$mailer->setBody($body);
				$mailer->Send();
					JError::raiseError( 403, JText::_( 'Access Forbidden' ));
					return false;
				}
			}

			if($element->payment_params->environnement == 'sandbox'){
				 $element->payment_params->url = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
			} else {
				 $element->payment_params->url = 'https://www.paypal.com/cgi-bin/webscr';
			}
			$url = parse_url($element->payment_params->url);

			if(!isset($url['query'])){
			$url['query'] = '';
			}
			if(!isset($url['port'])){
				if(!empty($url['scheme'])&&in_array($url['scheme'],array('https','ssl'))){
					$url['port'] = 443;
				}else{
				$url['port'] = 80;
				}
			}
			if(!empty($url['scheme'])&&in_array($url['scheme'],array('https','ssl'))){
				$url['host_socket'] = 'ssl://'.$url['host'];
			}else{
				$url['host_socket'] = $url['host'];
			}

			if($element->payment_params->debug){
				echo print_r($url,true)."\n\n\n";
			}

			$fp = fsockopen ( $url['host_socket'], $url['port'], $errno, $errstr, 30);
			if (!$fp) {
				//send an email
				$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','Paypal').' '.JText::sprintf('PAYPAL_CONNECTION_FAILED',$dbOrder->order_number));
				$body = str_replace('<br/>',"\r\n",JText::sprintf('NOTIFICATION_REFUSED_NO_CONNECTION','Paypal'))."\r\n\r\n".JText::sprintf('CHECK_DOCUMENTATION',HIKASHOP_HELPURL.'payment-paypal-error#connection').$order_text;
				$mailer->setBody($body);
				$mailer->Send();
				JError::raiseError( 403, JText::_( 'Access Forbidden' ));
				return false;
			}

			$uri = $url['path'].($url['query']!='' ? '?' . $url['query'] : '');
			$header = "POST $uri HTTP/1.0\r\n".
			"User-Agent: PHP/".phpversion()."\r\n".
			"Referer: ".hikashop_currentURL()."\r\n".
			"Server: ".$_SERVER['SERVER_SOFTWARE']."\r\n".
			"Host: ".$url['host'].":".$url['port']."\r\n".
			"Content-Type: application/x-www-form-urlencoded\r\n".
			"Content-Length: ".strlen($data)."\r\n".
			"Accept: */"."*\r\n\r\n";

			fwrite($fp, $header . $data);
		$response = '';
		while (!feof($fp)) {
			$response .= fgets ($fp, 1024);
		}
		fclose ($fp);

		if($element->payment_params->debug){
			echo print_r($header,true)."\n\n\n";
			echo print_r($data,true)."\n\n\n";
			echo print_r($response,true)."\n\n\n";
		}

		//remove header
		$response = substr($response, strpos($response, "\r\n\r\n") + strlen("\r\n\r\n"));

	// Check the txn_type > if not subscr_signup || subscr_payment >> send an email.
		$validTypes = array('subscr_signup','subscr_payment');
		$isValid = in_array($vars['txn_type'], $validTypes);
		if(isset($vars['txn_type']) && !$isValid){
			if($vars['txn_type'] == 'subscr_cancel'){
				$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','PaypalRecurring').'invalid transaction');
				$body = JText::sprintf("Hello,\r\n A paypal notification was refused because the txn type 'subscr_cancel' is not accepted.")."\r\n\r\n".$order_text;
			}
			else if($vars['txn_type'] == 'subscr_modify'){
				$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','PaypalRecurring').'invalid txn type');
				$body = JText::sprintf("Hello,\r\n A paypal notification was refused because the txn type 'subscr_modify' is not accepted")."\r\n\r\n".$order_text;
			}
			else if($vars['txn_type'] == 'subscr_eot'){
				// Send it to the customer
				$mailClass = hikashop_get('class.mail');
				$mailClass->sendMailEot($order, $vars);
				return false;
			}
			else{
				$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','PaypalRecurring').'invalid txn type');
				$body = JText::sprintf("Hello,\r\n A paypal notification was refused because the txn type is not recognized")."\r\n\r\n".$order_text;

			}
			$mailer->setBody($body);
			$mailer->Send();
			return false;
		}
		if(isset($vars['recurring']) && (int)$vars['recurring'] != 1 ){
			// Not a recurring payment.
			return false;
		}



		$verified = preg_match( "#VERIFIED#i", $response);
		if(!$verified){
			if(preg_match("#INVALID#i", $response)){
				$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','Paypal').'invalid transaction');
				$body = JText::sprintf("Hello,\r\n A paypal notification was refused because it could not be verified by the paypal server")."\r\n\r\n".JText::sprintf('CHECK_DOCUMENTATION',HIKASHOP_HELPURL.'payment-paypal-error#invalidtnx').$order_text;
				$mailer->setBody($body);
				$mailer->Send();
				if($element->payment_params->debug){
					echo 'invalid transaction'."\n\n\n";

				}
			}else{
				// error
				$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','Paypal').'invalid response');
				$body = JText::sprintf("Hello,\r\n A paypal notification was refused because the response from the paypal server was invalid")."\r\n\r\n".JText::sprintf('CHECK_DOCUMENTATION',HIKASHOP_HELPURL.'payment-paypal-error#invalidresponse').$order_text;
				$mailer->setBody($body);
				$mailer->Send();
				if($element->payment_params->debug){
					echo 'invalid response'."\n\n\n";

				}
			}
			return false;
		}
		if(!isset($vars['payment_status']))$vars['payment_status']='';
		$completed = preg_match("#Completed#i", $vars['payment_status']);
		$pending = preg_match("#Pending#i", $vars['payment_status']);

		 if (!$completed && !$pending) {
		 	//invalid
		 	/*
The status of the payment:
Canceled_Reversal: A reversal has been canceled. For example, you won a dispute with the customer, and the funds for the transaction that was reversed have been returned to you.
Completed: The payment has been completed, and the funds have been added successfully to your account balance.
Created: A German ELV payment is made using Express Checkout.
Denied: You denied the payment. This happens only if the payment was previously pending because of possible reasons described for the pending_reason variable or the Fraud_Management_Filters_x variable.
Expired: This authorization has expired and cannot be captured.
Failed: The payment has failed. This happens only if the payment was made from your customer’s bank account.
Pending: The payment is pending. See pending_reason for more information.
Refunded: You refunded the payment.
Reversed: A payment was reversed due to a chargeback or other type of reversal. The funds have been removed from your account balance and returned to the buyer. The reason for the reversal is specified in the ReasonCode element.
Processed: A payment has been accepted.
Voided: This authorization has been voided.
				*/
			$body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS','Paypal',$vars['payment_status'])).' '.JText::_('STATUS_NOT_CHANGED')."\r\n\r\n".JText::sprintf('CHECK_DOCUMENTATION',HIKASHOP_HELPURL.'payment-paypal-error#status').$order_text;
		 	$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION_FOR_ORDER','Paypal',$vars['payment_status'],$dbOrder->order_number));
			$mailer->setBody($body);
			$mailer->Send();
			if($element->payment_params->debug){
				echo 'payment '.$vars['payment_status']."\n\n\n";
			}
			return false;
		 }
		echo "Order id: ".$order->order_id."\n\n\n";
		echo 'PayPal transaction id: '.$vars['txn_id']."\n\n\n";
		$order->history = new stdClass();
		$order->history->history_reason=JText::sprintf('AUTOMATIC_PAYMENT_NOTIFICATION');
		$order->history->history_notified=0;
		$order->history->history_amount=@$vars['mc_gross'].@$vars['mc_currency'];
		$order->history->history_payment_id = $element->payment_id;
		$order->history->history_payment_method =$element->payment_type;
		$order->history->history_data = ob_get_clean();
		$order->history->history_type = 'payment';

	 	//valid
	 	$currencyClass = hikashop_get('class.currency');
		$currencies=null;
		$currencies = $currencyClass->getCurrencies($dbOrder->order_currency_id,$currencies);
		$currency=$currencies[$dbOrder->order_currency_id];
	 	$price_check = round($dbOrder->order_full_price, (int)$currency->currency_locale['int_frac_digits'] );
// Two different mc_gross(1)
	 	$mc_gross = isset($vars['mc_gross'])?$vars['mc_gross']:@$vars['mc_gross1'];
	 	if($price_check != @$mc_gross || $currency->currency_code != @$vars['mc_currency']){
	 		//price amount received is not good

		 //Check if recurring payment
	 		if($order->old_status->order_status != 'confirmed'){ // Not recurring (1st payment)
		 		$order->order_status = $element->payment_params->invalid_status;
		 		$orderClass->save($order);
		 		$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','Paypal').JText::_('INVALID_AMOUNT'));
				$body = str_replace('<br/>',"\r\n",JText::sprintf('AMOUNT_RECEIVED_DIFFERENT_FROM_ORDER','Paypal',$order->history->history_amount,$price_check.$currency->currency_code))."\r\n\r\n".JText::sprintf('CHECK_DOCUMENTATION',HIKASHOP_HELPURL.'payment-paypal-error#amount').$order_text;
	 		}else{ // Don't change the order status
	 			// Wrong amount, the subscription wasn't renewed
		 		$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','Paypal').JText::_('INVALID_AMOUNT'));
				$body = str_replace('<br/>',"\r\n",JText::sprintf('AMOUNT_RECEIVED_DIFFERENT_FROM_ORDER','Paypal',$order->history->history_amount,$price_check.$currency->currency_code))."\r\n\r\n".JText::sprintf('CHECK_DOCUMENTATION',HIKASHOP_HELPURL.'payment-paypal-error#amount').$order_text;
	 		}
			$mailer->setBody($body);
			$mailer->Send();
	 		return false;
	 	}
		// change the order ID > new order ID if recurring payment && not 1st payment
		$oldNumber = $order->order_number;
		$order->history->history_data .= JText::sprintf('RECURRING_PAYMENT_FOR_ORIGINAL_ORDER',$order->order_number);

		$tax_amount = 0;
		if(!empty($order->order_tax_info)){
			foreach($order->order_tax_info as $taxInfo){
				$tax_amount = @$taxInfo->tax_amount;
			}
		}
		$order->cart->full_total = null;
		$order->cart->full_total->prices[0]->price_value = $order->order_full_price - $tax_amount;
		$order->cart->full_total->prices[0]->price_value_with_tax = $order->order_full_price;
		$order->cart->full_total->prices[0]->price_currency_id = $order->order_currency_id;


		if($order->old_status->order_status == 'confirmed'){
			// Load the cart in the previous order > to save it in the new cart.
			$orderClass->loadProducts($order);
			$order->cart->products = $order->products;
			unset($order->order_id);
			unset($order->order_number);
			if(isset($order->order_invoice_id)){
				unset($order->order_invoice_id);
				unset($order->order_invoice_number);
			}
		}
	 	if($completed){
	 		$order->order_status = $element->payment_params->verified_status;
	 	}else{
	 		$order->order_status = $element->payment_params->pending_status;
	 		$order_text = JText::sprintf('CHECK_DOCUMENTATION',HIKASHOP_HELPURL.'payment-paypal-error#pending')."\r\n\r\n".$order_text;
	 	}
	 	if(isset($order->order_id) && $dbOrder->order_status == $order->order_status) return true;
		$config =& hikashop_config();
		if($config->get('order_confirmed_status','confirmed')==$order->order_status){
			$order->history->history_notified=1;
		}
	 /*
address: The payment is pending because your customer did not include a confirmed shipping address and your Payment Receiving Preferences is set to allow you to manually accept or deny each of these payments. To change your preference, go to the Preferences section of your Profile.
authorization: You set the payment action to Authorization and have not yet captured funds.
echeck: The payment is pending because it was made by an eCheck that has not yet cleared.
intl: The payment is pending because you hold a non-U.S. account and do not have a withdrawal mechanism. You must manually accept or deny this payment from your Account Overview.
multi-currency: You do not have a balance in the currency sent, and you do not have your Payment Receiving Preferences set to automatically convert and accept this payment. You must manually accept or deny this payment.
order: You set the payment action to Order and have not yet captured funds.
paymentreview: The payment is pending while it is being reviewed by PayPal for risk.
unilateral: The payment is pending because it was made to an email address that is not yet registered or confirmed.
upgrade: The payment is pending because it was made via credit card and you must upgrade your account to Business or Premier status in order to receive the funds. upgrade can also mean that you have reached the monthly limit for transactions on your account.
verify: The payment is pending because you are not yet verified. You must verify your account before you can accept this payment.
other: The payment is pending for a reason other than those listed above. For more information, contact PayPal Customer Service.
	*/

	 	$order->mail_status=$statuses[$order->order_status];
	 	$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION_FOR_ORDER','Paypal',$vars['payment_status'],$oldNumber));
		$body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS','Paypal',$vars['payment_status'])).' '.JText::sprintf('ORDER_STATUS_CHANGED',$order->mail_status)."\r\n\r\n".$order_text;
		$mailer->setBody($body);
		$mailer->Send();
		//email from paypal
		//$order->customer->user_email = $vars['payer_email'];

		$order->history->history_data .= "\n".date("d-m-Y")." -- ".date("H:i")."\n";

		// If instalment: Update the payment_params, check the validity of the instalment
		if(!is_array($fullOrder->order_payment_params))
			$fullOrder->order_payment_params = unserialize($fullOrder->order_payment_params);

		if(!empty($fullOrder->order_payment_params) && isset($fullOrder->order_payment_params['parent_order_id']) && isset($fullOrder->order_payment_params['total_instalment'])){
			$order->history->history_data .= "<br/>instalment check<br/>";

			$mainstatus = '';
			// If status == invalid >> change main order status to "Cancelled"
			if($order->order_status == $element->payment_params->invalid_status){
				$order->history->history_data .= "instalment cancelled";
				$mainStatus = $element->payment_params->invalid_status;
			}

			// if status == confirmed > change the status of the main order
			if($order->order_status == $element->payment_params->verified_status){
				$order->history->history_data .= "change main order status";
				$mainStatus = $order->order_status;
			}
			// If status == valid && total_instalment == current_instalment >> Change main order status to "Completed"
			if($order->order_status == $element->payment_params->verified_status && $fullOrder->order_payment_params['current_instalment'] == $fullOrder->order_payment_params['total_instalment']){
				$order->history->history_data .= "last instalment";
				$mainStatus = 'completed';
			}
			// If main status defined > update it
			if(!empty($mainStatus)){
				// Call the class for the save
				$mainOrder = $orderClass->get((int)@$fullOrder->order_payment_params['parent_order_id']);
				$mainOrder->order_status = $mainStatus;
				$orderClass->save($mainOrder);
			}
			$fullOrder->order_payment_params['current_instalment'] = $fullOrder->order_payment_params['current_instalment'] + 1;
			$order->order_payment_params = serialize($fullOrder->order_payment_params);
		}
	 	$orderClass->save($order);
		return true;
	}

	function onPaymentConfiguration(&$element){
		$subtask = JRequest::getCmd('subtask','');
		if($subtask=='ips'){
			$ips = null;
		echo implode(',',$this->_getIPList($ips));
		exit;
		}else{
			$this->paypal = JRequest::getCmd('name','paypalrecurring');
		if(empty($element)){
			$element = new stdClass();
				$element->payment_name='PayPal Recurring';
				$element->payment_description='You can pay by credit card or paypal using this recurring payment method';
				$element->payment_images='MasterCard,VISA,Credit_card,PayPal';
				$element->payment_type=$this->paypal;
				$element->payment_params= new stdClass();
				$element->payment_params->url='https://www.paypal.com/cgi-bin/webscr';
				$element->payment_params->notification=1;
				$list=null;
				$element->payment_params->ips='';
				$element->payment_params->details=0;
				$element->payment_params->invalid_status='cancelled';
				$element->payment_params->pending_status='created';
				$element->payment_params->verified_status='confirmed';
				$element->payment_params->address_override=1;
				$element = array($element);
			}
			$obj = reset($element);
		if(empty($obj->payment_params->email)){
			$app = JFactory::getApplication();
			$lang = JFactory::getLanguage();
			$locale=strtolower(substr($lang->get('tag'),0,2));
			$app->enqueueMessage(JText::sprintf('ENTER_INFO_REGISTER_IF_NEEDED','PayPal',JText::_('HIKA_EMAIL'),'PayPal','https://www.paypal.com/'.$locale.'/mrb/pal=SXL9FKNKGAEM8'));
		}

		$this->toolbar = array(
				'save',
				'apply',
				'cancel',
				'|',
				array('name' => 'pophelp', 'target' =>'payment-paypalrecurring-form')
			);
		hikashop_setTitle('Paypalrecurring','plugin','plugins&plugin_type=payment&task=edit&name='.$this->paypal);
		$app = JFactory::getApplication();
		$app->setUserState( HIKASHOP_COMPONENT.'.payment_plugin_type', $this->paypal);
		$this->address = hikashop_get('type.address');
		$this->category = hikashop_get('type.categorysub');
		$this->category->type = 'status';
		}
	}

	function onPaymentConfigurationSave(&$element){
		if(!empty($element->payment_params->ips)){
			$element->payment_params->ips=explode(',',$element->payment_params->ips);
		}
	return true;
	}

	function _getIPList(&$ipList){
		$paypal1 = gethostbynamel('www.paypal.com');
		$paypal2 = gethostbynamel('notify.paypal.com');
		$paypal3 = gethostbynamel('ipn.sandbox.paypal.com');
		$ipList = array();
		if(!empty($paypal1)){
			$ipList = $paypal1;
		}
		if(!empty($paypal2)){
			$ipList = array_merge($ipList,$paypal2);
		}
		if(!empty($paypal3)){
			$ipList = array_merge($ipList,$paypal3);
		}


		if(!empty($ipList)){
			$newList = array();
			foreach($ipList as $k => $ip){
				$ipParts = explode('.',$ip);
				if(count($ipParts)==4){
					array_pop($ipParts);
					$ip = implode('.',$ipParts).'.*';
				}
				if(!in_array($ip,$newList)){
					$newList[]=$ip;
				}
			}
			$ipList = $newList;
		}
		return $ipList;
	}

	function _toPPDuration($days){
		$ret = (object)array(
			'unit'		=> 'D',
			'value'		=> $days
		);

		// 0-90 => return days
		if($days < 90) return $ret;

		// Translate to weeks, months and years
		$weeks = (int)($days / 7);
		$months = (int)($days / 30);
		$years = (int)($days / 365);

		// Find which one is the closest match
		$deltaW = abs($days - $weeks*7);
		$deltaM = abs($days - $months*30);
		$deltaY = abs($days - $years*365);
		$minDelta = min($deltaW, $deltaM, $deltaY);

		// Counting weeks gives a better approximation
		if($minDelta == $deltaW) {
			$ret->unit = 'W';
			$ret->value = $weeks;

			// Make sure we have 1-52 weeks, otherwise go for a months or years
			if(($ret->value > 0) && ($ret->value <= 52)) {
				return $ret;
			} else {
				$minDelta = min($deltaM, $deltaY);
			}
		}

		// Counting months gives a better approximation
		if($minDelta == $deltaM) {
			$ret->unit = 'M';
			$ret->value = $months;

			// Make sure we have 1-24 month, otherwise go for years
			if(($ret->value > 0) && ($ret->value <= 24)) {
				return $ret;
			} else {
				$minDelta = min($deltaM, $deltaY);
			}
		}

		// If we're here, we're better off translating to years
		$ret->unit = 'Y';
		$ret->value = $years;

		if($ret->value < 0) {
			// Too short? Make it 1 (should never happen)
			$ret->value = 1;
		} elseif($ret->value > 5) {
			// One major pitfall. You can't have renewal periods over 5 years.
			$ret->value = 5;
		}
		return $ret;
	}
}